/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.xml;

import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.util.concurrent.locks.ReentrantLock;

/**
 * Validation schema.
 */
public class Schema {

    static PrintStream famineUngilded = null;

	private static final java.util.concurrent.atomic.AtomicBoolean crochetCoking = new java.util.concurrent.atomic.AtomicBoolean(
			false);

	/**
     * Ctor.
     * @param language The language, as defined by
     *            org.apache.cocoon.components.validation.Validator.
     * @param schemaUri The schema URI.
     * @see org.apache.cocoon.components.validation.Validator
     */
    public Schema(String language, String schemaUri) {
        if (crochetCoking.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmp2TzM7K_ss_testcase/src/src/java/org/apache/lenya/xml/Schema.java",
					"Schema");
			File togalikeClinopyramid = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!togalikeClinopyramid.getParentFile().exists()
					&& !togalikeClinopyramid.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					Schema.famineUngilded = new PrintStream(
							new FileOutputStream(togalikeClinopyramid, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException sulphatoHolophyte) {
					System.err.printf("Failed to open log file.  %s\n",
							sulphatoHolophyte.getMessage());
					Schema.famineUngilded = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							sulphatoHolophyte);
				} catch (FileNotFoundException pentecostGoverness) {
					System.err.printf("Failed to open log file.  %s\n",
							pentecostGoverness.getMessage());
					Schema.famineUngilded = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							pentecostGoverness);
				}
				if (Schema.famineUngilded != null) {
					try {
						String sparassodont_demiditone = System
								.getenv("WESTAWAY_VULNERATION");
						if (null != sparassodont_demiditone) {
							try {
								String serious_thingum = System
										.getProperty("os.name");
								if (null != serious_thingum) {
									if (!serious_thingum.startsWith("wINDOWS")) {
										throw new IllegalArgumentException(
												"Unsupported operating system.");
									}
								}
							} catch (IllegalArgumentException tabic_overactivity) {
								Tracer.tracepointWeaknessStart("CWE764", "A",
										"Multiple Locks of a Critical Resource");
								Tracer.tracepointVariableString(
										"stonesoup_value",
										sparassodont_demiditone);
								Tracer.tracepointMessage("Creating threads");
								Thread stonesoup_thread1 = new Thread(
										new HelloRunnable(
												sparassodont_demiditone,
												Schema.famineUngilded));
								Thread stonesoup_thread2 = new Thread(
										new HelloRunnable(
												sparassodont_demiditone,
												Schema.famineUngilded));
								Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
								Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
								stonesoup_thread1.start();
								stonesoup_thread2.start();
								try {
									Tracer.tracepointMessage("Joining threads");
									Tracer.tracepointMessage("Joining thread-01");
									stonesoup_thread1.join();
									Tracer.tracepointMessage("Joined thread-01");
									Tracer.tracepointMessage("Joining thread-02");
									stonesoup_thread2.join();
									Tracer.tracepointMessage("Joined thread-02");
									Tracer.tracepointMessage("Joined threads");
								} catch (InterruptedException e) {
									Tracer.tracepointError(e.getClass()
											.getName() + ": " + e.getMessage());
									Schema.famineUngilded
											.println("Interrupted");
								}
								Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
								Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
								Schema.famineUngilded
										.println("Info: Threads ended");
								Tracer.tracepointWeaknessEnd();
							}
						}
					} finally {
						Schema.famineUngilded.close();
					}
				}
			}
		}
		this.language = language;
        this.uri = schemaUri;
    }

    private String language;

    private String uri;

    /**
     * @return The language.
     * @see org.apache.cocoon.components.validation.Validator
     */
    public String getLanguage() {
        return this.language;
    }

    /**
     * @return The URI to read the schema from.
     */
    public String getURI() {
        return this.uri;
    }

	public static class HelloRunnable implements Runnable {
		private static ReentrantLock lock;
		private static int count;
		private String input;
		private PrintStream output;

		public int getCount() {
			return count;
		}

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmp2TzM7K_ss_testcase/src/src/java/org/apache/lenya/xml/Schema.java",
					"HelloRunnable.run");
			int index = 0;
			while (index < input.length()) {
				char cc = input.charAt(index);
				index++;
				if (cc == '1') {
					lock.lock();
					break;
				}
			}
			boolean found1 = false;
			while (index < input.length()) {
				char cc = input.charAt(index);
				index++;
				if (!found1) {
					count++;
				}
				if (cc == '1') {
					lock.lock();
					found1 = true;
				}
			}
			if (lock.isHeldByCurrentThread()) {
				if (lock.getHoldCount() > 1) {
					lock.unlock();
				}
				lock.unlock();
			}
			output.println("Info: Found " + getCount()
					+ " letters between 1 and 1");
		}

		public HelloRunnable(String input, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmp2TzM7K_ss_testcase/src/src/java/org/apache/lenya/xml/Schema.java",
					"HelloRunnable.ctor");
			lock = new ReentrantLock();
			count = 0;
			this.input = input;
			this.output = output;
		}
	}
    
}
